/********************************************************************************************/
/*																							*/
/*		݂͂ITvO~Oy														*/
/*		jRtU݂͂	܂Â胂f Qi							*/
/*		wk`J@SV[Y	5@M@낤̊							*/
/*																							*/
/*																							*/
/*				lqiCRjvOi7SEG\ւ  eXgf[^Mpj		*/
/*																							*/
/*																							*/
/*		PROGRAM			:	C														*/
/*		PROGRAM ID		:	main.c															*/
/*																							*/
/*																							*/
/*																							*/
/********************************************************************************************/
/*		n[hEGA	:	CPU			:PIC16F1827	(8BIT CPU)								*/
/*							NbN	:8MHz()											*/
/*							GPIO		:RA0-7 RB0-4 gp									*/
/*		J		:	RpC	:MPLABX XC8 v2.10									*/
/*								:MPLABX	IDE v2.35									*/
/*																							*/
/*																							*/
/*------------------------------------------------------------------------------------------*/
/*		@\Tv		:	7SEG\ɑ΂āARB1,RB2,RB3pAeXgf[^o͂B	*/
/*							o̓f[^ƂāA 410i 102371bԊu1DOWNf[^*/
/*							𑗐MB													*/
/*																							*/
/********************************************************************************************/
/*			RB1(STB),RB2(CLK),RB3(DAT)͊Oւ̐Mo͗płB							*/
/*			ȉ̃^C~OŃf[^𑗐MB											*/
/*																							*/
/*			*-------------------------------------------------------------------*			*/
/*	STB	____|		   10PULSE													|_____		*/
/*			          *-----*    *-----*    *-----* 										*/
/*	CLK	______________|     |____|     |____|     |__________`_______						*/
/*			     *----------*          *----------*											*/
/*	DAT	_________|	  1	    |_____0____|     1    |__________`_______						*/
/*																							*/
/*			4ms   4ms	4ms   4ms  4ms														*/
/********************************************************************************************/
/********************************************************************************************/
/*																							*/
/*		C																			*/
/*		VERSION			:	V1.00@2022/2/5@ VK쐬									*/
/*		V1.01	2022/02/10	(Q)\ŁAMf[^肱ڂB101`2		*/
/*								Mf[^肱ڂB									*/
/*							()\STB/CLK/DATXL̏Ԃ2.3ms	*/
/*								BCLKM̃NbN2msŒ`ĂB				*/
/*								̂߁AXL1NbNۂƓĂ܂		*/
/*								^C~OAf[^NĂ܂ĂB		*/
/*							(Ή)CLKM̕4msɕύXB								*/
/*		V1.02	2022/02/11	()f[^MTIMER0荞ݏŁAs֐pӂB	*/
/*								APł́Asend_dataɒlB							*/
/*								data_send2m() f[^M2(荞ݗp)					*/
/********************************************************************************************/
/*==========================================================================================*/
/*																							*/
/*				** PIC 16F1827 szu} **												*/
/*																							*/
/*					 +\\\ t \\\+														*/
/*			    RA2 [| 1           18 |] RA1												*/
/*				     |                |     												*/
/*				RA3 [| 2           17 |] RA0												*/
/*				     |                |     												*/
/*				RA4 [| 3           16 |] RA7												*/
/*				     |                |     												*/
/*		      !MCLR [| 4           15 |] RA6												*/
/*				     |                |     												*/
/*		        VSS [| 5           14 |] VDD												*/
/*				     |                |     												*/
/*			    RB0 [| 6           13 |] RB7												*/
/*				     |                |     			RB1,RB2,RB3͊Oւ̐Mo͗p	*/
/*	STB	 	    RB1 [| 7           12 |] RB6			Bȉ̃^C~OŃf[^	*/
/*				     |                |     			MB							*/
/*	CLK		    RB2 [| 8           11 |] RB5			*-----------------------*			*/
/*				     |                |     	STB	____|		10PULSE			|_____		*/
/*	DAT		    RB3 [| 9           10 |] RB4			        *-----* 					*/
/*					 +\\\\\\\\+			CLK	_______ ____|     |___`__________		*/
/*														   *----------*						*/
/*												DAT	_______|		  |___`__________		*/
/*																							*/
/*			 											4ms 4ms	  4ms 					*/
/*==========================================================================================*/
/*==========================================================================================*/
/*==========================================================================================*/
/*																							*/
/*				** 7SEG  4\ OSL40562 szu} **									*/
/*																							*/
/*					 +\\\ t \\\+									A					*/
/*		RA1		  E [| 1           12 |] DIG1-CN RB4				 -------				*/
/*				     |                |     						|		|				*/
/*		RA2		  D [| 2           11 |] A		 RB0			 F	|		| B				*/
/*				     |                |     						|	G	|				*/
/*		RA6		  DP[| 3           10 |] F		 RA0				 -------				*/
/*				     |                |     						|		|				*/
/*		RA3		  C [| 4            9 |] DIG2-CN RB5			 E	|		| C				*/
/*				     |                |     						|	D	|				*/
/*		RA7		  G [| 5            8 |] DIG3-CN RB6				 -------				*/
/*				     |                |     								  *	DP			*/
/*		RB7	 DIG4-CN[| 6            7 |] B		 RA4										*/
/*				     |                |     					DIG4 DIG3 DIG2 DIG1			*/
/*					 +\\\\\\\\+							W	 W	   W	W			*/
/*																							*/
/*																							*/
/*==========================================================================================*/
/********************************************************************************************/
/*	CN[ht@C																	*/
/********************************************************************************************/

#include <xc.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
/********************************************************************************************/
/*	vg^Cv錾																		*/
/********************************************************************************************/

int		data_sndm(void);						/* f[^M(APp)						*/
void	data_send2m(void);						/* f[^M2(荞ݗp)				*/

/********************************************************************************************/
/*	ft@C`																			*/
/********************************************************************************************/
#define ON			1							/* ON										*/
#define OFF			0							/* OFF										*/

#define _XTAL_FREQ	8000000						/* NbN() 8MHz					*/

#define STB			RB1							/* ۰ސM								*/
#define CLK			RB2							/* ۯM									*/
#define DAT			RB3							/* ۯM									*/

/********************************************************************************************/
/*	O[oϐ`																		*/
/********************************************************************************************/
int		send_data;								/* Mf[^								*/
int		s_count;								/* WAITJE^ϐ(1msP)				*/
int		s_n;									/* nrbgJE^(0-9)						*/
int		s_state;								/* MXe[gϐ							*/

/********************************************************************************************/
/*	RtBO[V`																*/
/********************************************************************************************/

// CONFIG1
#pragma config FOSC = INTOSC	// NbNgp
#pragma config WDTE = OFF		// WDT
#pragma config PWRTE = ON		// Power-up Timer Enable (PWRT enabled)
#pragma config MCLRE = ON		// MCLR Pin Function Select (MCLR/VPP pin function is digital input)
#pragma config CP = OFF			// Flash Program Memory Code Protection (Program memory code protection is disabled)
#pragma config CPD = OFF		// Data Memory Code Protection (Data memory code protection is disabled)
#pragma config BOREN = ON		// Brown-out Reset Enable (Brown-out Reset enabled)
#pragma config CLKOUTEN = ON	// 1/4NbNo (ONŖł邱Ƃɒ)
#pragma config IESO = OFF		// Internal/External Switchover (Internal/External Switchover mode is disabled)
#pragma config FCMEN = OFF		// Fail-Safe Clock Monitor Enable (Fail-Safe Clock Monitor is disabled)

// CONFIG2
#pragma config WRT = OFF		// Flash Memory Self-Write Protection (Write protection off)
#pragma config PLLEN = OFF		// PLL Enable (4x PLL disabled)
#pragma config STVREN = OFF		// Stack Overflow/Underflow Reset Enable (Stack Overflow or Underflow will cause a Reset)
#pragma config BORV = HI		// Brown-out Reset Voltage Selection (Brown-out Reset Voltage (Vbor), high trip point selected.)
#pragma config LVP = OFF		// Low-Voltage Programming Enable (High-voltage on MCLR/VPP must be used for programming)
/********************************************************************************************/
/*	`																				*/
/********************************************************************************************/
/********************************************************************************************/
/*																							*/
/*		MODULE			:	^C}[0荞ݏ(10ms)										*/
/*		MODULE ID		:	InterTimer														*/
/*																							*/
/*		CALLING SEQUENCE:	void interrupt InterTimer(void)									*/
/*																							*/
/*		PARAMETER		:	Ȃ															*/
/*																							*/
/*		RETURN VALUE	:	Ȃ															*/
/*																							*/
/*		FUNCTION		:	^C}[0ɂ1ms荞ݏ									*/
/*																							*/
/********************************************************************************************/

void interrupt InterTimer(void)					/* 荞ݏ								*/
{
	/*** [Jϐ ***/
	/*** Jn ***/
	if(TMR0IF == 1)								/* TMR0 荞ݗv					*/
    {

    	TMR0 = 240;								/* ^C}[0 x[XlăZcg				*/
												/* ̒lJEgUPAI[o[t[	*/
    											/* (255𒴂ꍇ)A荞݂		*/
    	TMR0IF = 0;								/* ^C}[0 荞ݗvNA				*/

		data_send2m();							/* f[^M2							*/
    }
}
/********************************************************************************************/
/*																							*/
/*		MODULE			:	f[^M													*/
/*		MODULE ID		:	dtat_sendm														*/
/*																							*/
/*		CALLING SEQUENCE:	void data_sendm(void)											*/
/*																							*/
/*		PARAMETER		:	Ȃ															*/
/*																							*/
/*		RETURN VALUE	:	Ȃ															*/
/*																							*/
/*		FUNCTION		:	f[^𑗐MB												*/
/*							AvP[VőMꍇɎgpB					*/
/*							  ̏ŁA8ms̎Ԃ邱ƂɒӁB					*/
/********************************************************************************************/
/*			RB1(STB),RB2(CLK),RB3(DAT)͊Oւ̐Mo͗płB							*/
/*			ȉ̃^C~OŃf[^𑗐MB											*/
/*																							*/
/*			*-------------------------------------------------------------------*			*/
/*	STB	____|		   10PULSE													|_____		*/
/*			          *-----*    *-----*    *-----* 										*/
/*	CLK	______________|     |____|     |____|     |__________`_______						*/
/*			     *----------*          *----------*											*/
/*	DAT	_________|	  1	    |_____0____|     1    |__________`_______						*/
/*																							*/
/*			4ms   4ms	4ms   4ms  4ms														*/
/********************************************************************************************/
int	data_sendm(void)							/* f[^M							*/
{
	/*** [Jϐ ***/
	int		i;									/* [vJE^							*/
	int		ptn;								/* }XNp^[i[ϐ					*/
	/*** Jn ***/
	STB = ON;									/* STBM ON								*/
	__delay_ms(2);								/* 2ms WAIT									*/

	for(i=0;i<10;i++)
	{
		ptn = 0x0001<<i;
		if(send_data & ptn)						/* BIT n								*/
		{
			DAT = ON;							/* DAT ON									*/
		}else
		{
			DAT = OFF;							/* DAT OFF									*/
		}
		__delay_ms(4);							/* 2ms WAIT									*/
		CLK = ON;								/* CLKM ON								*/
		__delay_ms(4);							/* 2ms WAIT									*/
		CLK = OFF;								/* CLKM OFF								*/
	}
	STB = OFF;									/* STBM OFF								*/

}
/********************************************************************************************/
/*																							*/
/*		MODULE			:	f[^M2													*/
/*		MODULE ID		:	dtat_send2m														*/
/*																							*/
/*		CALLING SEQUENCE:	void data_send2m(void)											*/
/*																							*/
/*		PARAMETER		:	Ȃ															*/
/*																							*/
/*		RETURN VALUE	:	Ȃ															*/
/*																							*/
/*		FUNCTION		:	f[^𑗐MB												*/
/*							荞ݏőMꍇɎgpB						*/
/*							  Xe[gƂA̋N̏Ԃɗ͏ȂĂ	*/
/*							  1ms荞ݏŎgp邱ƂOƂĂB				*/
/********************************************************************************************/
/*			RB1(STB),RB2(CLK),RB3(DAT)͊Oւ̐Mo͗płB							*/
/*			ȉ̃^C~OŃf[^𑗐MB											*/
/*																							*/
/*			*-------------------------------------------------------------------*			*/
/*	STB	____|		   10PULSE													|_____		*/
/*			          *-----*    *-----*    *-----* 										*/
/*	CLK	______________|     |____|     |____|     |__________`_______						*/
/*			     *----------*          *----------*											*/
/*	DAT	_________|	  1	    |_____0____|     1    |__________`_______						*/
/*																							*/
/*			4ms   4ms	4ms   4ms  4ms														*/
/********************************************************************************************/
void	data_send2m(void)						/* f[^M2							*/
{
	/*** [Jϐ ***/
	int		dt;									/* f[^ꎞҏWp							*/
	/*** Jn ***/
	switch(s_state)								/* MXe[g							*/
	{
		case 1:									/* MXe[g1̏ꍇ						*/
												/* [STBMONZbg]						*/
			STB = ON;							/* STBM ON								*/
			s_n = 0;							/* nrbgJE^0Zbg					*/
			s_count = 1;						/* WAITJE^1Zbg						*/
			s_state = 2;						/* MXe[g2							*/
			break;
		case 2:									/* MXe[g2̏ꍇ						*/
												/* [DATMONZbg]						*/
			dt = (send_data>>s_n) & 0x0001;		/* Mf[^ nrbgVtg BIT0o		*/
			if( dt == 0x0001)					/* BIT n 1							*/
			{									/* BIT n 1̏ꍇ							*/
				DAT = ON;						/* DATM ON								*/
			}									/*											*/
			else								/* BIT n 0̏ꍇ							*/
			{									/*											*/
				DAT = OFF;						/* DATM OFF								*/
			}									/*											*/
			s_n++;								/* nrbgJE^1UP						*/
			s_count = 1;						/* WAITJE^1Zbg						*/
			s_state = 3;						/* MXe[g3							*/
			break;
		case 3:									/* MXe[g3̏ꍇ						*/
												/* [4ms ҂]								*/
			s_count++;							/* WAITJE^1UP							*/
			if(s_count > 3)						/* WAITJE^ 3唻					*/
			{									/* ̏ꍇ								*/
				s_state = 4;					/* MXe[g4							*/
			}
			break;
		case 4:									/* MXe[g4̏ꍇ						*/
												/* [CLKMONZbg]						*/
			CLK = ON;							/* CLKM ON								*/
			s_count = 1;						/* WAITJE^1Zbg						*/
			s_state = 5;						/* MXe[g5							*/
			break;
		case 5:									/* MXe[g5̏ꍇ						*/
												/* [4ms ҂]								*/
			s_count++;							/* WAITJE^1UP							*/
			if(s_count > 3)						/* WAITJE^ 3唻					*/
			{									/* ̏ꍇ								*/
				s_state = 6;					/* MXe[g6							*/
			}
			break;
		case 6:									/* MXe[g6̏ꍇ						*/
												/* [CLKMOFFZbg]						*/
			CLK = OFF;							/* CLKM OFF								*/
			if(s_n > 9)							/* nrbgJE^ 9唻				*/
			{									/* ̏ꍇ								*/
				s_state = 7;					/* MXe[g7							*/
			}									/*											*/
			else								/* 9łȂꍇ						*/
			{									/*											*/
				s_state = 2;					/* MXe[g2							*/
			}
			break;
		case 7:									/* MXe[g7̏ꍇ						*/
												/* [4ms ҂]								*/
			s_count++;							/* WAITJE^1UP							*/
			if(s_count > 3)						/* WAITJE^ 3唻					*/
			{									/* ̏ꍇ								*/
				s_state = 8;					/* MXe[g8							*/
			}
			break;
		case 8:									/* MXe[g8̏ꍇ						*/
												/* [STBMOFFZbg]						*/
			STB = OFF;							/* STBM OFF								*/
			s_count = 1;						/* WAITJE^1Zbg						*/
			s_state = 9;						/* MXe[g9							*/
			break;
		case 9:									/* MXe[g9̏ꍇ						*/
												/* [4ms ҂]								*/
			s_count++;							/* WAITJE^1UP							*/
			if(s_count > 3)						/* WAITJE^ 3唻					*/
			{									/* ̏ꍇ								*/
				s_state = 1;					/* MXe[g1							*/
			}
			break;
	}
}
/********************************************************************************************/
/*																							*/
/*		MODULE			:	C														*/
/*		MODULE ID		:	main															*/
/*																							*/
/*		CALLING SEQUENCE:	void main(void)													*/
/*																							*/
/*		PARAMETER		:	Ȃ															*/
/*																							*/
/*		RETURN VALUE	:	Ȃ															*/
/*																							*/
/*		FUNCTION		:	C[v\B										*/
/*																							*/
/********************************************************************************************/

void main(void)
{
	/*** [Jϐ ***/
	int		val;
	/*** Jn ***/
//												/* WX^lݒ						*/
    OSCCON 		= 0b01110010;    				/* NbN8lgƂ				*/
    OPTION_REG 	= 0b00000000;					/* B5=0:ۯ(Fosc/4)TIMER0gpAB0-2=000:ؽ׶Ēl 1:2*/
    ANSELA      = 0b00000000;					/*											*/
	ANSELB 		= 0b00000000;					/*											*/
	TRISA  		= 0b00100000;					/* s(RA)͑Sďo͂ɊĂ(ARA5͓݂͂̂ƂȂ)*/
	TRISB  		= 0b00000000;					/* s(RB)͑Sďo͂ɊĂ		        */
	PORTA  		= 0b00000000;					/* RAo̓s̏(SLOWɂ)		*/
	PORTB  		= 0b00000000;					/* RBo̓s̏(SLOWɂ)		*/

    
    OPTION_REG = 0b00000110;					/* ۯ(Fosc/4)TIMER0gpAؽ׶Ēl 1:128*/

	TMR0   = 99;								/* ^C}[0 JEgx[Xl Zbg		*/
	TMR0IF = 0;									/* ^C}[0ݗvtONA	*/
	TMR0IE = 1;									/* ^C}[0݂				*/
//	PEIE = 1;									/* ӊ݂						*/
	GIE    = 1;									/* CPU荞ݏ				*/

	s_state = 1;								/* MXe[g 						*/
	send_data = 1023;							/* Mf[^								*/

	__delay_ms(100);							/* [vɓÕCjVpEGCg	*/
												/* Nɐݒ肪邽߂ɎԂ	*/
												/* ꍇBÔ߁A100msWAITu	*/


	while(1)									/* C[v								*/
	{											/*											*/

		__delay_ms(100);						/* 1s WAIT									*/
//		data_sendm();							/* f[^M								*/
		send_data--;							/* Mf[^ XV							*/
		if(send_data <0 )						/* Mf[^ŏlɒBƂ			*/
		{										/* őlɍXVB						*/
			send_data = 1023;					/*											*/
		}
	}
}
